program accepter;
uses lcore,
  lsocket,
  sockets,
  sysutils,
  hexconv,
  readtxt,
  binipstuff,
  packetstructures,// in 'packetstructures.pas',
  udpspoof,// in 'udpspoof.pas';
  {$ifdef ver1_0}
    linux;
  {$else}
    baseunix,unix;
  {$endif}
  {$i unixstuff.inc}
const
  udp_timeout=300; // 5 minuites
type
  tsc=class
    procedure available(sender:tobject;error:word);
    procedure receive(sender:tobject;error:word);
    procedure closed(sender:tobject;error:word);
    procedure winlinkreceive(sender:tobject;error:word);
    procedure winlinkconnected(sender:tobject;error:word);
    procedure udpreceive(sender:tobject;error:word);
  end;
  textendedsocket = class(tlsocket)
  public
    connectbuf : string;
    onwardconnected : boolean;
  end;
function uptospace(invalue:string): string;
begin
  setlength(invalue,pos(' ',invalue)-1);
  result := invalue;
end;
var
  listensocket : tlsocket;
  udpsocket    : tlsocket;
  sc : tsc;
  onwardsinuse : array[0..1023] of boolean;
  reverselookup : array[0..1023] of textendedsocket;
  winlink : tlsocket;
  winlinkdata : string;
type
  tudpmapping = record
    lastused : integer; // for reuse;
    localport : word;
  end;
var
  udpmappings : array[0..1023] of tudpmapping;

procedure tsc.available;
var
  port : integer;
  t : text;
  newsock : textendedsocket;
  coloncount : integer;
  counter : integer;
  line : string;
  remoteaddr : string;
  remoteport : integer;
  partcount : integer;
begin
  newsock := textendedsocket.create(nil);
  newsock.dup(listensocket.accept);
  port := strtoint(newsock.getpeerport);
  //writeln;
  //writeln('localport:'+inttostr(port));
  //writeln;
  assign(t,'/proc/net/tcp');
  reset(t);
  while not eof(t) do begin
    readln(t,line);
    coloncount := 0;
    for counter := 1 to length(line) do begin;
      if line[counter] = ':' then begin
        inc(coloncount);
     	case coloncount of
	  2: begin
	    if strtoint('$'+copy(line,counter+1,4)) <> port then break;
	  end;
	  3: begin
	    remoteport := strtoint('$'+copy(line,counter+1,4));
	    remoteaddr := '';
	    for partcount := 1 to 4 do begin
              if (partcount = 4) and (remoteaddr='192.0.2') then remoteaddr := '127.0.0';
	      if partcount <> 1 then remoteaddr := remoteaddr +'.';
	      remoteaddr := remoteaddr + inttostr(strtoint('$'+copy(line,counter-(partcount*2),2)));
	    end;
	    break
	  end;
	end;

      end;
      if remoteaddr <> '' then break;
    end;

  end;
  //writeln('addr:'+remoteaddr+' port:'+inttostr(remoteport));
  for counter := 0 to 1023 do begin
    if not onwardsinuse[counter] then begin
      newsock.tag := counter;
      reverselookup[counter] := newsock;
      break;
    end;
  end;
  onwardsinuse[newsock.tag] := true;
  winlink.sendstr(inttohex(newsock.tag,4)+'1'+remoteaddr+' '+inttostr(remoteport)+#10);
  newsock.ondataavailable := sc.receive;
  newsock.onsessionclosed := sc.closed;
end;

procedure tsc.receive;
begin
  with textendedsocket(sender) do begin
    if onwardconnected then begin
      winlink.sendstr(inttohex(tag,4)+'2'+hexenc(receivestr)+#10);
    end else begin
      connectbuf := connectbuf + receivestr;
    end;
  end;
end;

procedure tsc.closed;
var
  sock : textendedsocket;
begin
  sock := textendedsocket(sender);
  with sock do begin
    close;
    onwardsinuse[sock.tag] := false;
    winlink.sendstr(inttohex(sock.tag,4)+'3'+#10);

  end;
end;

procedure tsc.winlinkreceive;
var
  line : string;
  pos10 : integer;
  connectionno : integer;
  cmd : char;
  counter : integer;
  foundspace : boolean;
  addr : string;
  port : string;
  encodeddata  : string;
  spacesfound  : integer;
  packettarget : string;
  tempstring   : string;
  t            : treadtext;
  inaddr       : tsockaddrin;
  data : string;
begin
  //writeln('winlinkreceive entered');
  winlinkdata := winlinkdata+winlink.ReceiveStr;
  pos10 := pos(#10,winlinkdata);
  while pos10 <> 0 do begin
    line := winlinkdata;
    setlength(line,pos10-1);
    move(winlinkdata[pos10+1],winlinkdata[1],length(winlinkdata)-pos10);
    setlength(winlinkdata,length(winlinkdata)-pos10);
    if length(line) >= 5 then begin
      connectionno := strtoint('$'+copy(line,1,4));
      cmd := line[5];
      move(line[6],line[1],length(line)-5);
      setlength(line,length(line)-5);

      if cmd = 'A' then begin
        //writeln('parseing a udp line');
        //writeln(udpmappings[connectionno].localport);
        if udpmappings[connectionno].localport <> 0 then begin
          Addr := '';
          port := '';
          encodeddata := '';
          //foundspace := false;
          spacesfound := 0;
          for counter := 1 to length(line) do begin
            if line[counter] = ' ' then begin
              inc(spacesfound);
            end else begin
              case spacesfound of
                0: addr := addr + line[counter];
                1: port := port + line[counter];
                2: encodeddata := encodeddata + line[counter];
              end;

            end;

          end;
          //writeln('addr:'+addr);
          //writeln('port:'+port);
          //writeln('localport:',udpmappings[connectionno].localport);
          //addr := '1.2.3.4';
          packettarget := '';
          readtext_init(t,'/proc/net/ip_conntrack');
          while not readtext_eof(t) do begin
            line := readtext_line(t);
            if uppercase(copy(line,1,3))='UDP' then begin

              if (addr=uptospace(copy(line,pos('dst=',line)+4,16))) and
               (port=uptospace(copy(line,pos('dport=',line)+6,6))) and
               (udpmappings[connectionno].localport=strtoint(uptospace(copy(line,pos('sport=',line)+6,6)))) then begin
                //writeln('dst='+destaddr);

                // port to send packet to
                //tempstring := copy(line,pos('[',line),65536);
                tempstring := copy(line,pos('dport=',line)+6,65536);
                packettarget := copy(tempstring,pos('dport=',tempstring)+6,6);
                setlength(packettarget,pos(' ',packettarget)-1);
              end;
            end;
          end;
          //closefile(t);
          readtext_close(t);

          data :=hexdec(encodeddata);
          if packettarget ='' then begin
            sendpacket(longip(addr),strtoint(port),$7f000001{$0A000046},udpmappings[connectionno].localport,data);
          end else begin
            inaddr.family := af_inet;
            inaddr.port := htons(strtoint(packettarget));
            inaddr.addr := htonl($7f000001);
            udpsocket.sendto(inaddr,sizeof(inaddr),pchar(data),length(data));
          end;
        end;
        //writeln('parsed a udp line');

      end;
      if onwardsinuse[connectionno] then case cmd of
        '1': begin
          //connected
          winlink.sendstr(inttohex(connectionno,4)+'2'+hexenc(reverselookup[connectionno].connectbuf)+#10);
          reverselookup[connectionno].onwardconnected :=true;
          //writeln('onward connected');
        end;
        '2': begin
          //send
          //write(line);
          //write(hexdec(line));
          if reverselookup[connectionno].state = wsconnected then begin
            reverselookup[connectionno].sendstr(hexdec(line));
          end;
        end;
        '3': begin
          //close
          reverselookup[connectionno].close;
          reverselookup[connectionno].release;
          onwardsinuse[connectionno] := false;
        end;
      end;
    end;
    pos10 := pos(#10,winlinkdata);

  end;
  //writeln('winlinkreceive finished');

end;

procedure tsc.winlinkconnected;
begin
  //writeln('connected to windows side error '+inttostr(error));
end;

procedure tsc.udpreceive;
var
  s: string;
  src : tinetsockaddr;
  srclen : integer;
  t : treadtext;
  port : integer;
  line : string;
  tempstring : string;
  destaddr : string;
  destport : string;
  sourceport : string;
  sourceporti : integer;
  connection : integer;
  counter : integer;
begin
  setlength(s,65536);
  srclen := sizeof(src);
  setlength(s,udpsocket.receivefrom(@s[1],65536,src,srclen));
  //writeln(inttohex(src.addr,8)+' '+inttohex(src.port,4));
  port := htons(src.port);

  //assign(t,'/proc/net/ip_conntrack');
  //reset(t);
  readtext_init(t,'/proc/net/ip_conntrack');
  while not readtext_eof(t) do begin
    //writeln('about to read line');
    //readln(t,line);
    line := readtext_line(t);
    //writeln('read line');
    //writeln(line);
    if uppercase(copy(line,1,3))='UDP' then begin
      //writeln('found a udp line');
      //writeln('line is '+line);
      tempstring := copy(line,pos('dport=',line)+6,65536);
      //writeln(tempstring);
      tempstring := copy(tempstring,pos('dport=',tempstring)+6,6);
      //writeln('sport='+tempstring);
      setlength(tempstring,pos(' ',tempstring)-1);
      //writeln('extracted dport it is '+tempstring);
      if strtoint(tempstring)=port then begin
        //writeln('found');
        //writeln(line);
        //writeln;
        destaddr := copy(line,pos('dst=',line)+4,16);
        //writeln('dst='+destaddr);
        setlength(destaddr,pos(' ',destaddr)-1);
        destport := copy(line,pos('dport=',line)+6,6);
        setlength(destport,pos(' ',destport)-1);
        sourceport := copy(line,pos('sport=',line)+6,6);
        setlength(sourceport,pos(' ',sourceport)-1);

      end;
    end;
  end;
  //closefile(t);
  readtext_close(t);
  //writeln;
  if copy(destaddr,1,8)='192.0.2.' then destaddr := '127.0.0.'+copy(destaddr,9,3);

  //writeln('sourceport='+sourceport+' destaddr='+destaddr+' destport='+destport);
  connection := -1;
  if (sourceport <> '') and (destport <> '') and (destaddr <> '') then begin
    sourceporti := strtoint(sourceport);
    //writeln(sourceporti);
    for counter := 0 to 1023 do begin
      if udpmappings[counter].localport = sourceporti then begin
        connection := counter;
        //writeln('existing mapping used localport:',sourceport);
        break;
      end;
    end;
    if connection = -1 then for counter := 0 to 1023 do begin
      if udpmappings[counter].lastused < gettimeofdaysec - udp_timeout then begin
        connection := counter;
        udpmappings[counter].localport := sourceporti;
        //writeln('new mapping made localport:',sourceport);
        break;
      end;

    end;
    udpmappings[counter].lastused := gettimeofdaysec;
    //writeln;
    //writeln(connection);
    //writeln(hexenc(s));
    //writeln;
    //writeln(s);
    if connection >=0 then winlink.sendstr(inttohex(connection,4)+'A'+destaddr+' '+destport+' '+hexenc(s)+#10)

    //sendpacket(longip(destaddr),strtoint(destport),$7f000001,strtoint(sourceport),s);
  end;
end;

begin
  //writeln(inttohex(longip('127.0.0.1'),8));
  fillchar(onwardsinuse,sizeof(onwardsinuse),0);
  fillchar(udpmappings,sizeof(udpmappings),0);
  winlink := tlsocket.create(nil);
  winlink.addr := paramstr(1);
  winlink.port := '9999';
  winlink.ondataavailable := sc.winlinkreceive;
  winlink.onsessionconnected := sc.winlinkconnected;
  winlink.connect;


  listensocket := tlsocket.create(nil);
  listensocket.port := '9999';
  listensocket.onsessionavailable := sc.available;
  listensocket.listen;
  udpsocket := tlsocket.create(nil);
  udpsocket.port := '9999';
  udpsocket.proto := 'udp';
  udpsocket.ondataavailable := sc.udpreceive;
  udpsocket.listen;

  messageloop;
end.