program connector;

uses
  wcore,
  winsock,
  wsocket,
  binipstuff,
  hexconv in 'hexconv.pas',
  windows,sysutils,classes;

type
  tsc=class
    procedure linuxlinkavailable(sender:tobject;error:word);
    procedure linuxlinkreceive(sender:tobject;error:word);
    procedure connected(sender:tobject;error:word);
    procedure receive(sender:tobject;error:word);
    procedure udpreceive(sender:tobject;error:word);
    procedure closed(sender:tobject;error:word);
  end;
  tinetsockaddr = tsockaddrin;
var
  listener : twsocket;
  linuxlink : twsocket;
  connections : array[0..1023] of twsocket;
  udpconnections : array[0..1023] of twsocket;
  sc : tsc;
  linuxlinkdata : string;
procedure tsc.linuxlinkavailable;
begin
  linuxlink.dup(listener.accept);

end;

function longipreverse(a:longint):string;
begin
  result := inttostr(a shr 24)+'.'+inttostr((a shr 16) and $ff)+'.'+inttostr((a shr 8) and $ff)+'.'+inttostr(a and $ff);
end;

procedure parsetcpline(line:string;cmd:char;connectionno:integer);
var
  foundspace : boolean;
  counter : integer;
begin
  if not assigned(connections[connectionno]) then begin
    connections[connectionno] := twsocket.create(nil);
    connections[connectionno].tag := connectionno;
    connections[connectionno].OnSessionConnected := sc.connected;
    connections[connectionno].OnDataAvailable := sc.receive;
    connections[connectionno].OnSessionClosed := sc.closed;
  end;
  case cmd of
    '1': begin
      //connect
      connections[connectionno].Addr := '';
      connections[connectionno].port := '';
      foundspace := false;
      for counter := 1 to length(line) do begin
        if line[counter] = ' ' then begin
          foundspace := true;
        end else begin
          if foundspace then begin
            connections[connectionno].port := connections[connectionno].port + line[counter];
          end else begin
            connections[connectionno].addr := connections[connectionno].addr + line[counter];
          end;
        end;
      end;
      connections[connectionno].connect;
    end;
    '2': begin
      //send
      //write(hexdec(line));
      if connections[connectionno].state = wsconnected then begin
        connections[connectionno].sendstr(hexdec(line));
      end;
    end;
    '3': begin
      //close
      connections[connectionno].close;
    end;
  end;
end;



procedure parseudpline(line:string;cmd:char;connectionno:integer);
var
  foundspace : boolean;
  counter : integer;
  addr : string;
  port : string;
  encodeddata : string;
  spacesfound : integer;
  inaddr : tinetsockaddr;
  data : string;
begin
 try
  if not assigned(udpconnections[connectionno]) then begin
    udpconnections[connectionno] := twsocket.create(nil);
    udpconnections[connectionno].tag := connectionno;
//    udpconnections[connectionno].OnSessionConnected := sc.connected;
    udpconnections[connectionno].OnDataAvailable := sc.udpreceive;
//    udpconnections[connectionno].OnSessionClosed := sc.udpclosed;
    udpconnections[connectionno].addr := '0.0.0.0';
    udpconnections[connectionno].port := '0';
    udpconnections[connectionno].proto := 'udp';
    udpconnections[connectionno].listen;
  end;
  case cmd of
    'A': begin
      //send
      //write(hexdec(line));
      Addr := '';
      port := '';
      encodeddata := '';
      //foundspace := false;
      spacesfound := 0;
      for counter := 1 to length(line) do begin
        if line[counter] = ' ' then begin
          inc(spacesfound);
        end else begin
          case spacesfound of
            0: addr := addr + line[counter];
            1: port := port + line[counter];
            2: encodeddata := encodeddata + line[counter];
          end;
        end;
      end;
      //inet_aton(
      inaddr.sin_family := af_inet;
      inaddr.sin_addr.S_addr := htonl(longip(addr));
      inaddr.sin_port := htons(strtoint(port));


      if udpconnections[connectionno].state = wsconnected then begin
        data := hexdec(encodeddata);
        //writeln;
        //writeln(addr);
        //writeln(port);
        //writeln(hexenc(data));
        //writeln;
        udpconnections[connectionno].sendto(inaddr,sizeof(inaddr), pchar(data),length(data) );

      end;
    end;
  end;
 except
   on e: exception do begin
     writeln('exception of class '+e.classname+' with message '+ e.message);
   end;
 end;
end;


procedure tsc.linuxlinkreceive;
var
  line : string;
  pos10 : integer;
  connectionno : integer;
  cmd : char;


begin
  linuxlinkdata := linuxlinkdata+linuxlink.ReceiveStr;
  pos10 := pos(#10,linuxlinkdata);
  while pos10 <> 0 do begin
    line := linuxlinkdata;
    setlength(line,pos10-1);
    move(linuxlinkdata[pos10+1],linuxlinkdata[1],length(linuxlinkdata)-pos10);
    setlength(linuxlinkdata,length(linuxlinkdata)-pos10);
    if length(line) >= 5 then begin
      connectionno := strtoint('$'+copy(line,1,4));
      cmd := line[5];
      move(line[6],line[1],length(line)-5);
      setlength(line,length(line)-5);
      case cmd of
        '0'..'9': begin
           parsetcpline(line,cmd,connectionno);
        end;
        'A'..'Z': begin
           parseudpline(line,cmd,connectionno);
        end;
      end;
    end;
    pos10 := pos(#10,linuxlinkdata);

  end;

end;




procedure tsc.connected;
begin
  linuxlink.Sendstr(inttohex(tcomponent(sender).tag,4)+'1'+inttostr(error)+#10);
end;

procedure tsc.receive;
var
  data : string;
begin
  data := twsocket(sender).receivestr;
  //writeln(hexenc(data));
  linuxlink.Sendstr(inttohex(tcomponent(sender).tag,4)+'2'+hexenc(data)+#10)
end;

procedure tsc.udpreceive;
var
  data : string;
  inaddr : TSockAddrIn;
  numrecv : integer;
  fromlen : integer;
begin
  //writeln('in udpreceive');
  setlength(data,65535);
  fromlen := sizeof(inaddr);
  inaddr.sin_family := af_inet;

  numrecv := TWSocket(sender).ReceiveFrom(pchar(data),length(data),inaddr,fromlen);
  writeln(numrecv);
  if numrecv <>-1 then begin
    setlength(data,numrecv);
    //data := twsocket(sender).receivestr;
    //writeln(hexenc(data));
    linuxlink.Sendstr(inttohex(tcomponent(sender).tag,4)+'A'+longipreverse(htonl(inaddr.sin_addr.S_addr))+' '+inttostr(htons(inaddr.sin_port))+' '+hexenc(data)+#10)
  end;
  //writeln('udpreceive done');
end;


procedure tsc.closed;
begin
  linuxlink.Sendstr(inttohex(tcomponent(sender).tag,4)+'3'+inttostr(error)+#10);
end;

begin
  zeromemory(@connections,sizeof(connections));
  zeromemory(@udpconnections,sizeof(connections));
  linuxlink := twsocket.create(nil);
  linuxlink.OnDataAvailable := sc.linuxlinkreceive;
  linuxlinkdata := '';
  listener := twsocket.create(nil);
  listener.onsessionavailable := sc.linuxlinkavailable;
  listener.port := '9999';
  listener.Addr := '0.0.0.0';
  listener.listen;
  writeln('initialised');
  writeln(longipreverse($7F000001));
  messageloop;
end.
