unit logincmds;

interface
uses
  buser , bstuff , accountuseingbot ;
{own account}
procedure priv_login(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountuseingbot);

procedure priv_deauth(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobj:taccountuseingbot);
procedure priv_newpass(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountuseingbot);
procedure priv_drop(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountuseingbot);

implementation
uses
  accountcore , blinklist , bparse , bcmds , passcryp , binipstuff, unitbanmask;

procedure priv_login(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountuseingbot);
var
  a:integer;
  p:taccount;
  sl:tstringlinklist;
  s1,s2,s3:string;
  pp:tplinklist;

begin
 with botobject do begin
  {
  check:
  - is already logged in to anything
  - someone is already logged in to account
  - is ircop
  - mask
  - password.

  then associate user with account and account with user
  }


  {if (parv[2] = '') or (parc < 3) then begin
    send(sendtalk+cmd+' <username> <password>');
    exit;
  end;}
  if not localloginchecks(sptr,parc,parv,msg) then exit;
  if taccountuseingserviceunit(srvunit).accountcore.getaccountfromuser(sptr) <> nil then begin
    if not ismortal(sptr) then send(sendtalk+'Sorry, You are already authenticated as '+sptr.account);
    exit;
  end;

  p := taccountuseingserviceunit(srvunit).accountcore.findaccount(parv[1]);
  if p = nil then begin
    if not ismortal(sptr) then send(sendtalk+'AUTHENTICATION FAILED as '+parv[1]+'. Account does not exist.');
    exit;
  end;

  {if operonly: check}
  if not isoper(sptr) then if p.operonly then begin
    logaction(sptr,'Failed login to '+p.name+': not IRCop');
    if not ismortal(sptr) then send(sendtalk+'AUTHENTICATION FAILED as '+p.name+'. You''re not IRC Operator.');
    exit;
  end;

  if (p.password = '') then begin
    logaction(sptr,'Failed login to '+p.name+': account disabled.');
    if not ismortal(sptr) then send(sendtalk+'AUTHENTICATION FAILED as '+p.name+'. Account disabled.');
    exit;
  end;

  s1 := sptr.name+'!'+sptr.userid+'@'+sptr.host;
  s2 := sptr.name+'!'+sptr.userid+'@'+ircipbintostr(sptr.binip);
  sl := p.mask;
  a := 0;
  while sl <> nil do begin
    s3 := sl.s;
    if maskmatchup(s3,s1) or maskmatchup(s3,s2) then begin
      a := 1;
      break;
    end;
    sl := tstringlinklist(sl.next);
  end;
  if a = 0 then begin
    logaction(sptr,'Failed login to '+p.name+': mask does not match');
    if not ismortal(sptr) then send(sendtalk+'AUTHENTICATION FAILED as '+p.name+'. Your mask does not match.');
    exit;
  end;

  if not taccountuseingserviceunit(srvunit).accountcore.accountpasswordmatch(p,parv[2]) then begin
    logaction(sptr,'Failed login to '+p.name+', Password incorrect.');
    if not ismortal(sptr) then send(sendtalk+'AUTHENTICATION FAILED as '+p.name+'. Password incorrect.');
    exit;
  end;


  pp := p.user;
  while pp <> nil do begin
    send(sendprefixstr(mybot)+TOK_NOTICE+' '+tuser(pp.p).idstr+' :'+nickuserhost(sptr)+' logged in to your account.');
    pp := tplinklist(pp.next);
  end;

  //sendparse(me.idstr+' '+TOK_ACCOUNT+' '+sptr.idstr+' '+ parv[1]);
  taccountuseingserviceunit(srvunit).accountcore.login(sptr,parv[1]);
  send(sendtalk+'AUTHENTICATION SUCCESSFUL as '+p.name+'.');

  p.requestedpass := '';
  p.password := passnewcrypt(parv[2]);

  if p.level = 0 then p.level := 1;
(*  logaction(sptr,'LOGIN');*)
 end;
end;
procedure priv_deauth(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobj:taccountuseingbot);
begin
 with botobj do begin
  if taccountuseingserviceunit(srvunit).accountcore.mode=0 then begin
    send(sendtalk+'account message system in use you can''t deauth');

  end else begin
    if taccountuseingserviceunit(srvunit).accountcore.getaccountfromuser(sptr) = nil then begin
      send(sendtalk+'You are not logged in.');
      exit;
    end;

    taccountuseingserviceunit(srvunit).accountcore.deauth(sptr);
    send(sendtalk+'You are logged off.');
  end;
 end;
end;

procedure priv_newpass(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountuseingbot);
var
  p:taccount;

begin
 with botobject do begin
  {if (parv[3] = '') or (parc < 4) then begin
    send(sendtalk+cmd+' <old> <new> <new>');
    exit;
  end;}

  p := taccountuseingserviceunit(srvunit).accountcore.getaccountfromuser(sptr);
  if p = nil then begin
    send(sendtalk+'You are not logged in.');
    exit;
  end;

  if (not taccountuseingserviceunit(srvunit).accountcore.accountpasswordmatch(p,parv[1])) then begin
    send(sendtalk+'password incorrect');
    exit;
  end;

  if (parv[2] <> parv[3]) then begin
    send(sendtalk+'new password mismatch');
    exit;
  end;

  if ircupper(parv[4])='PRECRYPT' then begin
    p.password := parv[3];
  end else begin
    p.password := passnewcrypt(parv[3]);
  end;


  logaction(sptr,'NEWPASS');
  send(sendtalk+'Your password has been changed.');
 end;
end;

procedure priv_drop(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountuseingbot);
var
  p:taccount;
begin
 with botobject do begin
  {if (parc < 3) or (parv[2] = '') then begin
    send(sendtalk+' To remove your account, type /msg A '+cmd+' <myusername> <mypassword>');
    exit
  end;}
  p := taccountuseingserviceunit(srvunit).accountcore.findaccount(parv[1]);
  if p <> taccountuseingserviceunit(srvunit).accountcore.getaccountfromuser(sptr) then begin
    send(sendtalk+'you can only drop your own account');
    exit;
  end;

  if taccountuseingserviceunit(srvunit).accountcore.getaccountfromuser(sptr) = nil then begin
    {this code will only run if the admin is a lamer and makes drop availablie to level -1 users}
    send(sendtalk+'you are not logged in');
    exit;
  end;

  if not taccountuseingserviceunit(srvunit).accountcore.accountpasswordmatch(p,parv[2]) then begin
    send(sendtalk+'password incorrect.');
    exit;
  end;

  send(sendtalk+'Your account has been deleted.');

  logaction(sptr,cmd+' '+p.name);
  linklistdel(tlinklist(taccountuseingserviceunit(srvunit).accountcore.accountlist),tlinklist(p));
  p.destroy;

  {}
 end;
end;

end.
